//this is needed for life calibration of windows positions

interface Positioning
{
void Run(object self);
void Stop(object self);	
}

class ContinuousPositioning112: thread
{  
image CamView
number CloseListener
number motherID
string ShiftValueName

number Ynormal
number width,height
number binning,exposure

number running,shifted



void Run(object self)
	{
	object mother = motherID.getScriptObjectfromID()
	
result("\nstart running ")	

	while(!spacedown()&&running)
		{		
		try
			{				
			CamView =AcquireUnprocessed112(exposure,binning,0,0,height,width)
			
			if(shifted)
				{
				number deltaY = mother.LookUpElement(ShiftValueName).DLGGetValue()				
				SetYShiftValue112(Ynormal+deltaY)
				}
			}
		catch{break;}
		}
		
	SetYShiftValue112(Ynormal)	
	} 
	
object  init(object self,number motherIDP,string ShiftValueNameP, number exposureP,number binningP,number widthP,number heightP)
	{
	motherID =motherIDP	
	ShiftValueName =ShiftValueNameP
	binning =binningP
	exposure =exposureP/binning/binning
	width =widthP/binning
	height = heightP/binning	
	
	CamView :=realimage("Camera view",4,width,height)
	CamView.showimage()
	
	Ynormal =GetYShiftValue112()
	
	running =1		
	self.StartThread("Run")

	return self
	}
	 
void DrawWindow(object self, number top,number left,number bottom,number right,string color)
	{
	ImageDisplay disp = CamView.ImageGetImageDisplay(0 )

	top /=binning
	left /=binning
	bottom /=binning
	right /=binning
	
	ROI Window = NewROI( ) 
	Window.ROISetVolatile(0)
	if(color=="red") 	Window.ROISetColor(1,0,0)
	if(color=="green") 	Window.ROISetColor(0,1,0)
	if(color=="blue") 	Window.ROISetColor(0,0,1)
	
	Window.ROISetRectangle(top,left,bottom,right)
	disp.ImageDisplayAddROI(Window) 	
	}

void Normal_Ymode(object self) // Y shift is controlled by microscope/Filter knobs
	{
	shifted =0
	
	SetYShiftValue112(Ynormal)
	}

void Shifted_Ymode(object self, number deltaY) // Y shift is controlled by script with initial value YshiftedP
	{
	shifted =1

	SetYShiftValue112(Ynormal +deltaY)//set initial value
	}

number StoreNormalY(object self)	//memorizes and return current Yvalue
	{
	if(shifted ==0) 
		{
		Ynormal =GetYShiftValue112()
		
		return Ynormal
		}	
	else {result("\nShould in normal (not shifted) mode !!");throw("");}
	}
	
				
void Stop(object self) 
	{
	imageDocument imDoc = ImageGetOrCreateImageDocument(CamView)
	imdoc.ImageDocumentGetWindow().WindowRemoveWindowListener(CloseListener)

	if(shifted ==1) SetYShiftValue112(Ynormal)	//restore the normal value
	
	running =0
	}	
	
~ContinuousPositioning112(object self) 
	{
	result("\nContinuousPositioning "+ self.ScriptObjectGetID()+" destroyed")
	}
}   

